Imports System.Drawing

Public MustInherit Class Drawable
    Protected Friend m_X As Integer = 0
    Protected Friend m_Y As Integer = 0
    Protected Friend m_Width As Integer = 50
    Protected Friend m_Height As Integer = 50
    Protected Friend m_BackColor As Color = Color.White
    Protected Friend m_ForeColor As Color = Color.Black

    Public Sub New()
    End Sub

    Public Sub New(ByVal x As Integer, ByVal y As Integer, ByVal wid As Integer, ByVal hgt As Integer, ByVal back_color As Color, ByVal fore_color As Color)
        m_X = x
        m_Y = y
        m_Width = wid
        m_Height = hgt
        m_BackColor = back_color
        m_ForeColor = fore_color
    End Sub

    Public MustOverride Sub Draw(ByVal gr As Graphics)
End Class

Public Class Rectangle
    Inherits Drawable

    Public Sub New(ByVal x As Integer, ByVal y As Integer, ByVal wid As Integer, ByVal hgt As Integer, ByVal back_color As Color, ByVal fore_color As Color)
        MyBase.New(x, y, wid, hgt, back_color, fore_color)
    End Sub

    Public Overrides Sub Draw(ByVal gr As System.Drawing.Graphics)
        Dim my_brush As New SolidBrush(m_BackColor)
        gr.FillRectangle(my_brush, m_X, m_Y, m_Width, m_Height)
        my_brush.Dispose()

        Dim my_pen As New Pen(m_ForeColor)
        gr.DrawRectangle(my_pen, m_X, m_Y, m_Width, m_Height)
        my_pen.Dispose()
    End Sub
End Class

Public Class Ellipse
    Inherits Drawable

    Public Sub New(ByVal x As Integer, ByVal y As Integer, ByVal wid As Integer, ByVal hgt As Integer, ByVal back_color As Color, ByVal fore_color As Color)
        MyBase.New(x, y, wid, hgt, back_color, fore_color)
    End Sub

    Public Overrides Sub Draw(ByVal gr As System.Drawing.Graphics)
        Dim my_brush As New SolidBrush(m_BackColor)
        gr.FillEllipse(my_brush, m_X, m_Y, m_Width, m_Height)
        my_brush.Dispose()

        Dim my_pen As New Pen(m_ForeColor)
        gr.DrawEllipse(my_pen, m_X, m_Y, m_Width, m_Height)
        my_pen.Dispose()
    End Sub
End Class